package com.link.core.contextholder;

import com.link.core.util.RedisUtil;
import com.link.core.util.redisclient.LinkRedisClient;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentLinkedQueue;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.CollectionUtils;
import org.springframework.web.context.request.RequestContextHolder;

public class RedisSecurityContextHolderbAK {
   private static Logger logger = LoggerFactory.getLogger(RedisSecurityContextHolderbAK.class);
   private static final String FUNCTION = "function";
   private static final String P1 = "p1";
   private static final String P2 = "p2";
   private static final String P3 = "p3";
   private static final String P4 = "p4";
   private static final String P5 = "p5";
   private static final String REDIS_CONTEXT_ATTRIBUTES = "REDIS_SECURITY_CONTEXT";

   public static void set(LkRdsFunctionP0 function) {
      ConcurrentLinkedQueue<Map<String, Object>> functions = get();
      if (CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      Map<String, Object> parmas = new HashMap(2);
      parmas.put("function", function);
      functions.add(parmas);
   }

   public static <P1> void set(LkRdsFunctionP1 function, P1 p1) {
      ConcurrentLinkedQueue<Map<String, Object>> functions = get();
      if (CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      Map<String, Object> parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      functions.add(parmas);
   }

   public static <P1, P2> void set(LkRdsFunctionP2 function, P1 p1, P2 p2) {
      ConcurrentLinkedQueue<Map<String, Object>> functions = get();
      if (CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      Map<String, Object> parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      parmas.put("p2", p2);
      functions.add(parmas);
   }

   public static <P1, P2, P3> void set(LkRdsFunctionP3 function, P1 p1, P2 p2, P3 p3) {
      ConcurrentLinkedQueue<Map<String, Object>> functions = get();
      if (CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      Map<String, Object> parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      parmas.put("p2", p2);
      parmas.put("p3", p3);
      functions.add(parmas);
   }

   public static <P1, P2, P3, P4> void set(LkRdsFunctionP4 function, P1 p1, P2 p2, P3 p3, P4 p4) {
      ConcurrentLinkedQueue<Map<String, Object>> functions = get();
      if (CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      Map<String, Object> parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      parmas.put("p2", p2);
      parmas.put("p3", p3);
      parmas.put("p4", p4);
      functions.add(parmas);
   }

   public static <P1, P2, P3, P4, P5> void set(LkRdsFunctionP5 function, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) {
      ConcurrentLinkedQueue<Map<String, Object>> functions = get();
      if (CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      Map<String, Object> parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      parmas.put("p2", p2);
      parmas.put("p3", p3);
      parmas.put("p4", p4);
      parmas.put("p5", p5);
      functions.add(parmas);
   }

   private static ConcurrentLinkedQueue<Map<String, Object>> get() {
      return (ConcurrentLinkedQueue)RequestContextHolder.currentRequestAttributes().getAttribute("REDIS_SECURITY_CONTEXT", 0);
   }

   public static void roolBack() {
      ConcurrentLinkedQueue<Map<String, Object>> functions = get();
      if (!CollectionUtils.isEmpty(functions)) {
         LinkRedisClient redisClient = null;

         try {
            for(redisClient = RedisUtil.getJedis(); !functions.isEmpty(); functions.remove()) {
               Map<String, Object> functionMap = (Map)functions.peek();
               Object function = functionMap.get("function");
               if (function instanceof LkRdsFunctionP0) {
                  ((LkRdsFunctionP0)function).accept(redisClient);
               }

               if (function instanceof LkRdsFunctionP1) {
                  ((LkRdsFunctionP1)function).accept(redisClient, functionMap.get("p1"));
               }

               if (function instanceof LkRdsFunctionP2) {
                  ((LkRdsFunctionP2)function).accept(redisClient, functionMap.get("p1"), functionMap.get("p2"));
               }

               if (function instanceof LkRdsFunctionP3) {
                  ((LkRdsFunctionP3)function).accept(redisClient, functionMap.get("p1"), functionMap.get("p2"), functionMap.get("p3"));
               }

               if (function instanceof LkRdsFunctionP4) {
                  ((LkRdsFunctionP4)function).accept(redisClient, functionMap.get("p1"), functionMap.get("p2"), functionMap.get("p3"), functionMap.get("p4"));
               }

               if (function instanceof LkRdsFunctionP5) {
                  ((LkRdsFunctionP5)function).accept(redisClient, functionMap.get("p1"), functionMap.get("p2"), functionMap.get("p3"), functionMap.get("p4"), functionMap.get("p5"));
               }
            }
         } catch (Exception var8) {
            Exception e = var8;
            logger.error("回滚redis错误：" + e.getMessage());
            logger.info("还没有进行回滚的操作有以下内容：");

            for(; !functions.isEmpty(); functions.remove()) {
               Map<String, Object> functionMap = (Map)functions.peek();
               Object function = functionMap.get("function");
               if (function instanceof LkRdsFunctionP0) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP0");
               }

               if (function instanceof LkRdsFunctionP1) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP1, 参数：" + functionMap.get("p1"));
               }

               if (function instanceof LkRdsFunctionP2) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP2, 参数：" + functionMap.get("p1") + "," + functionMap.get("p2"));
               }

               if (function instanceof LkRdsFunctionP3) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP3, 参数：" + functionMap.get("p1") + "," + functionMap.get("p2") + "," + functionMap.get("p3"));
               }

               if (function instanceof LkRdsFunctionP4) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP4, 参数：" + functionMap.get("p1") + "," + functionMap.get("p2") + "," + functionMap.get("p3") + "," + functionMap.get("p4"));
               }

               if (function instanceof LkRdsFunctionP5) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP5, 参数：" + functionMap.get("p1") + "," + functionMap.get("p2") + "," + functionMap.get("p3") + "," + functionMap.get("p4") + "," + functionMap.get("p5"));
               }
            }

            throw e;
         } finally {
            RedisUtil.returnResource(redisClient);
         }

      }
   }

   @FunctionalInterface
   public interface LkRdsFunctionP5<P1, P2, P3, P4, P5, R> {
      R accept(LinkRedisClient redis, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP4<P1, P2, P3, P4, R> {
      R accept(LinkRedisClient redis, P1 p1, P2 p2, P3 p3, P4 p4);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP3<P1, P2, P3, R> {
      R accept(LinkRedisClient redis, P1 p1, P2 p2, P3 p3);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP2<P1, P2, R> {
      R accept(LinkRedisClient redis, P1 p1, P2 p2);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP1<P1, R> {
      R accept(LinkRedisClient redis, P1 p1);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP0<R> {
      R accept(LinkRedisClient redis);
   }
}
